import React, {useState} from "react";
import {Link}            from 'react-router-dom';
import {connect}         from "react-redux";
import {actionFullLogin} from "./Reducers";

let Login = function({loginFeil, fullLogin}) {
    const [login, setLogin] = useState("");
    const [password, setPassword] = useState("");

    return (
        <section className="login">
            <h2>Форма логина</h2>
            <label>Введите ваш логин<br/>
                <input type="text"
                    placeholder="Введите ваш логин"
                    onChange={evt => setLogin(evt.target.value)} />
            </label>
            <label>Введите ваш пароль<br/>
                <input type="password"
                    placeholder="Введите ваш пароль"
                    onChange={evt => setPassword(evt.target.value)} />
            </label>
            <Link to="/password-change">Забыли пароль ?</Link>
            {loginFeil && <p>Не верный логин или пароль</p>}
            <button onClick={() => fullLogin(login, password)}>Войти</button>
        </section>
    );
};

const CLogin = connect(state => ({loginFeil: state.auth?.error}), {fullLogin: actionFullLogin})(Login)

export default CLogin;