import {backendURL, 
       actionEnndlessScrollAdFind, 
       actionEndlessScrollClear} from "./Reducers";
import {connect}                 from "react-redux";
import {Link}                    from 'react-router-dom';
import {useEffect}               from "react";

let AdItem = function({adItem: {createdAt, images, price, title, _id}}) {
    return (
        <li>
            <Link to={`/ad/${_id}`}>
                <img className="main-page__img"
                    src={images && images[0]?.url ? 
                    `${backendURL}/${images[0]?.url}` :
                    `${backendURL}/images/96ecc4298f6ffd0b0aaa957318fbeae5`}/>

                <h3>{title ? title : "Title"}</h3>
                <div>
                    <span>Цена: {price}</span><br/>
                    <span>{(new Date(+createdAt)).toLocaleString()}</span>
                </div>
            </Link>
        </li>
    );
};

let AdList = function({ArrAd}) {
    return (
        <ul className="main-page__list">
            {ArrAd.map(adItem => <AdItem adItem={adItem} />)}
        </ul>
    );
};

const CAdList = connect(state => ({ArrAd: state.scroll?.arr || []}))(AdList);

let MainPage = function({match: {params: {_id}}, userLogin, adFind, adClear}) {
    let checkScrollBottom = function() {
        if ((window.innerHeight + window.pageYOffset) >= document.body.offsetHeight) {
            adFind(_id, 10);
        };
    };

    useEffect(() => {
        window.addEventListener("scroll", checkScrollBottom);

        if(userLogin) {
            adFind(_id, 10);
        };

        return () => {
            window.removeEventListener("scroll", checkScrollBottom);
            adClear();
        };
    });

    return (
        <section className="main-page">
            <h2>Главная страница</h2>
            <input placeholder="Поиск" />
            {!!userLogin ? <CAdList /> :
                           <p>Для того что бы увидеть объявления нужно залогинится </p>}
        </section>
    );
};

const CMainPage = connect(state => ({userLogin: state.auth?.payload}), 
                                    {adFind: actionEnndlessScrollAdFind,
                                     adClear: actionEndlessScrollClear})(MainPage);

export default CMainPage;