import {useState}             from "react";
import {connect}              from "react-redux";
import {actionChangePassword} from "./Reducers";

let PasswordChange = function({changeFeil, changePassword}) {
    const [login, setLogin]             = useState("");
    const [password, setPassword]       = useState("");
    const [newPassword, setNewPassword] = useState("");

    return (
        <section className="password-change">
            <h2>Форма смены пароля</h2>
            <label>Введите ваш логин<br/>
                <input type="text"
                       placeholder="Введите ваш логин"
                       onChange={evt => setLogin(evt.target.value)} />
            </label>
            <label>Введите старый пароль<br/>
                <input type="password"
                       placeholder="Введите старый пароль"
                       onChange={evt => setPassword(evt.target.value)} />
            </label>
            <label>Введите новый пароль<br/>
                <input type="password"
                       placeholder="Введите новый пароль"
                       onChange={evt => setNewPassword(evt.target.value)} />
            </label>
            {changeFeil && <p>Не верный логин или пароль</p>}
            <button onClick={() => changePassword(login, password, newPassword)}>Сменить пароль</button>
        </section>
    );
};

const CPasswordChange = connect(state => ({changeFeil: state.auth?.error}),
                                          {changePassword: actionChangePassword})(PasswordChange)

export default CPasswordChange;