import {useState}                                          from "react";
import {connect}                                           from "react-redux";
import {Redirect} from 'react-router-dom';
import {backendURL, actionAboutUserById, actionAuthLogout} from "./Reducers";

let UserInfo = function({user: {addresses, createdAt, login, nick, phones}}) {
    return (
        <div>
            <h3>Инфо</h3>
            <table>
                <tr>
                    <td>Логин:</td>
                    <td>{login}</td>
                </tr>
                <tr>
                    <td>Никнейм:</td>
                    <td>{nick || "Отсутствует"}</td>
                </tr>
                <tr>
                    <td>Телефон:</td>
                    <td>{phones || "Отсутствует"}</td>
                </tr>
                <tr>
                    <td>Адрес:</td>
                    <td>{addresses || "Отсутствует"}</td>
                </tr>
                <tr>
                    <td>Зарегистрирован:</td>
                    <td>{(new Date(+createdAt)).toLocaleString()}</td>
                </tr>
            </table>
        </div>
    );
};

let Ad = function({}) {
    return (
        <div>
            <h3>Объявления</h3>
        </div>
    );
};

let Message = function({}) {
    return (
        <div>
            <h3>Сообщения</h3>
        </div>
    );
};

let ProfilePage = function({user, owner: {sub: {id}}, logout}) {
    const [show, setShow] = useState({info: true, ad: false, message: false});

    return (
        <section className="user-profile">
            <h2>{user?._id == id ? "Мой профиль" : `Профиль пользователя ${user?.login}`}</h2>
            <div className="user-profile__head">
                <img className="user-profile__avatar"
                     src={user?.avatar ?
                         `${backendURL}/${user?.avatar?.url}` :
                         `${backendURL}/images/96ecc4298f6ffd0b0aaa957318fbeae5`} />

                {user?._id == id && <button>Сменить аватар</button>}
                {user?._id == id && <button onClick={() => logout()}>Выйти из личного кабинета</button>}
            </div>
            <ul className="user-profile__list">
                <li><button onClick={() => setShow({info: true, ad: false, message: false})}>Общая информация</button></li>
                <li><button onClick={() => setShow({info: false, ad: true, message: false})}>Объявления</button></li>
                {user?._id == id && <li><button onClick={() => setShow({info: false, ad: false, message: true})}>Мои сообщения</button></li>}
            </ul>
            {show.info && <UserInfo user={user} />}
            {show.ad && <Ad />}
            {show.message && <Message />}
        </section>
    );
};

const CProfilePage = connect(state => ({user: state.promise?.aboutUserById?.payload || {},
                                        owner: state.auth?.payload}), 
                                       {logout: actionAuthLogout})(ProfilePage);

let Profile = function({match: {params: {_id}}, aboutUser}) {
    aboutUser(_id);
    return (
        <CProfilePage userId={_id} />
    );
};

const CProfile = connect(null, {aboutUser: actionAboutUserById})(Profile);

export default CProfile;