import createHistory from "history/createBrowserHistory";
import React         from 'react';
import ReactDOM      from 'react-dom';
import {Router}      from 'react-router-dom';
import {Provider}    from "react-redux";
import {store}       from './Reducers';
import Header        from "./Header";
import CMain          from './Main';
import "./index.scss";

const history = createHistory();

ReactDOM.render(
  <React.StrictMode>
    <Router history={history}>
      <Provider store={store}>
        <Header />
        <CMain />
      </Provider>
    </Router>
  </React.StrictMode>,
  document.getElementById('root')
);